﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=10
@EndOfDesignText@
#Event: dayclick, prevclick, nextclick, todayclick
#RaisesSynchronousEvents: dayclick, prevclick, nextclick, todayclick
' this is the B4J version!
Sub Class_Globals
	Private xui As XUI
	Private fx As JFX
	Private mCallback As Object
	Private mEventname As String
	Public lblticks As Long
	Private pnlpicker As Pane
	Public lblseldate As Label
	Public devwidth As Int
	Public devheight As Int
End Sub

Public Sub Initialize(Callback As Object, Eventname As String)
	mCallback = Callback
	mEventname = Eventname
End Sub

Public Sub set_month_panel(mnth As Int, yr As Int) As Pane
	Private daynumber As Int = 1
	Private	currentticks As Long = DateTime.Now
	Private currentmonth As Int = DateTime.GetMonth(currentticks)
	Private currentyear As Int = DateTime.GetYear(currentticks)
	Private currentday As Int = DateTime.GetDayOfMonth(currentticks)
	Private firstdayticks As Long
	Private leftpos As Int = 3dip
	Private toppos As Int = 5dip
	Private boxwidth As Int = 85dip
	Private boxheight As Int = 60dip
	Private pnl As Pane
	pnl.Initialize("pnl")
	pnl.RemoveAllNodes
	' screen adjustments
	devwidth = B4XPages.GetNativeParent(B4XPages.MainPage).RootPane.Width
	devheight = B4XPages.GetNativeParent(B4XPages.MainPage).RootPane.Height
	Private boxwidth As Int = DipToCurrent(devwidth/7)
	Private boxheight As Int = DipToCurrent(devheight/11)
	' date initializations
	firstdayticks = DateUtils.SetDate(yr,mnth,1)
	'
	Private daysequence As Int = 1			' 1 = monday-sunday	2 = sunday-saturday
	Private startdaynumber As Int = DateTime.GetDayOfWeek(firstdayticks)
	If daysequence = 1 Then
		If startdaynumber = 1 Then
			startdaynumber = 7
		Else
			startdaynumber = startdaynumber - 1
		End If
	End If
	'
	Private enddaynumber As Int = DateUtils.NumberOfDaysInMonth(mnth,yr)
	' month/year label
	Private lstmonthnames As List = Array As String("January","February","March","April","May","June","July","August","September","October","November","December")
	Private monthname As String = lstmonthnames.Get(mnth-1)
	Private lblmonth As Label = set_label(monthname & " " & yr, fx.Colors.From32Bit(0xFFB6DDF9),"")
	pnl.AddNode(lblmonth,leftpos,toppos,7*boxwidth,boxheight)
	' dayname labels row
	Private lstdaynames As List
	lstdaynames.Initialize
	'
	If daysequence = 1 Then
		lstdaynames = Array As String("Mon","Tue","Wed","Thu","Fri","Sat","Sun")
	Else
		lstdaynames = Array As String("Sun","Mon","Tue","Wed","Thu","Fri","Sat")			
	End If
	'
	For i = 1 To 7
		Private lbl As Label = set_label(lstdaynames.Get(i-1), fx.Colors.From32Bit(0xFFFFFF87),"")
		pnl.AddNode(lbl,leftpos+boxwidth*(i-1),toppos+boxheight,boxwidth,boxheight)
	Next
	' day number labels rows
	For r = 1 To 6
		For c = 1 To 7
			If c < startdaynumber And r = 1 Then
				Private lbl As Label = set_label("",fx.Colors.From32Bit(0xFFE6E6E6),"")
			Else
				If daynumber > enddaynumber Then
					Private lbl As Label = set_label("", fx.Colors.From32Bit(0xFFE6E6E6),"")
				Else
					If daynumber = currentday And mnth = currentmonth And yr = currentyear Then
						Private lbl As Label = set_label(daynumber, fx.Colors.From32Bit(0xFFFF3232),"lblday")
					Else
						'
						If daysequence = 2 Then
							' monday = 1 - sunday = 7
							If c = 1 Or c = 7 Then
								Private lbl As Label = set_label(daynumber, fx.Colors.From32Bit(0xFFFFD2B3),"lblday")
							Else
								Private lbl As Label = set_label(daynumber,fx.Colors.From32Bit(0xFF9EFF96),"lblday")
							End If
						Else
							' sunday = 1 - saturday = 7
							If c > 5 Then
								Private lbl As Label = set_label(daynumber, fx.Colors.From32Bit(0xFFFFD2B3),"lblday")
							Else
								Private lbl As Label = set_label(daynumber,fx.Colors.From32Bit(0xFF9EFF96),"lblday")
							End If
						End If
						'
					End If
					If File.Exists(xui.DefaultFolder,DateUtils.SetDate(yr,mnth,daynumber) & "_notes.txt") Then
						If daynumber = currentday And mnth = currentmonth And yr = currentyear Then
							Private lbl As Label = set_label(daynumber,fx.Colors.From32Bit(0xFFFFA500),"lblday")
						Else
							Private lbl As Label = set_label(daynumber,fx.Colors.From32Bit(0xFFFFFF00),"lblday")
						End If
					End If
					lbl.Tag = DateUtils.SetDate(yr,mnth,daynumber)
					daynumber = daynumber + 1
				End If
			End If
			pnl.AddNode(lbl,leftpos+boxwidth*(c-1),toppos+(boxheight*2)+boxheight*(r-1),boxwidth,boxheight)
		Next
	Next
	pnl.PrefWidth = 7 * boxwidth + 1dip
	pnl.PrefHeight = 8 * boxheight + 1dip
	Return pnl
End Sub

private Sub set_label(lbltext As String, backcolor As Paint, lbltag As String) As Label
	Private lbl As Label
	lbl.Initialize(lbltag)
	lbl.Alignment = "CENTER"
	CSSUtils.SetBackgroundColor(lbl,backcolor)
	CSSUtils.SetBorder(lbl,1,fx.Colors.From32Bit(0xFF000000),3)
	lbl.Font = fx.DefaultFont(16)
	lbl.TextSize = 16
	lbl.Text = lbltext
	Return lbl
End Sub

Public Sub set_date_picker(intmonth As Int, intyear As Int) As Pane
	devwidth = B4XPages.GetNativeParent(B4XPages.MainPage).RootPane.Width
	devheight = B4XPages.GetNativeParent(B4XPages.MainPage).RootPane.Height
	Log(devwidth)
	Log(devheight)
	pnlpicker.Initialize("pnlpicker")
	pnlpicker.RemoveAllNodes
	Private btnprev As Button = set_button("PREV",fx.Colors.From32Bit(0xFFB6DDF9),"btnprev")
	pnlpicker.AddNode(btnprev,0dip,0dip,70dip,40dip)
	Private btntoday As Button = set_button("NOW",fx.Colors.From32Bit(0xFFB6DDF9),"btntoday")
	pnlpicker.AddNode(btntoday,70dip,0dip,70dip,40dip)
	lblseldate = set_label("",fx.Colors.From32Bit(0xFFE6E6E6),"")
	pnlpicker.AddNode(lblseldate,140dip,0dip,devwidth-210dip,40dip)
	Private btnnext As Button = set_button("NEXT",fx.Colors.From32Bit(0xFFB6DDF9),"btnnext")
	pnlpicker.AddNode(btnnext,devwidth-70dip,0dip,70dip,40dip)
	Private pnlmonth As Pane
	pnlmonth.Initialize("pnlmonth")
	pnlmonth = set_month_panel(intmonth,intyear)
	pnlpicker.AddNode(pnlmonth,0dip,40dip,278dip,368dip)
	pnlpicker.SetLayoutAnimated(0dip, 0dip, 0dip, 278dip, 368dip)
	Return pnlpicker
End Sub
Private Sub set_button(btntext As String, backcolor As Paint, btntag As String) As Button
	Private btn As Button
	btn.Initialize(btntag)
	CSSUtils.SetBackgroundColor(btn,backcolor)
	CSSUtils.SetBorder(btn,1,fx.Colors.From32Bit(0xFF000000),3)
	btn.TextSize = 16
	btn.Text = btntext
	btn.Tag = btntag
	btn.Alignment = "CENTER"
	Return btn
End Sub

Public Sub lblday_MouseClicked(EventData As MouseEvent)
	Dim l As Label = Sender
	lblticks = l.tag
	'Log(lblticks)
	DateTime.DateFormat = "yyyy-MM-dd"
	lblseldate.Text = DateTime.Date(lblticks)
	If xui.SubExists(mCallback,mEventname & "_dayclick",2) Then
		CallSubDelayed(mCallback,mEventname & "_dayclick")
	End If
End Sub
Public Sub btnprev_MouseClicked(EventData As MouseEvent)
	If xui.SubExists(mCallback,mEventname & "_btnprevclick",2) Then
		CallSubDelayed(mCallback,mEventname & "_btnprevclick")
	End If
End Sub
Public Sub btnnext_MouseClicked(EventData As MouseEvent)
	If xui.SubExists(mCallback,mEventname & "_btnnextclick",2) Then
		CallSubDelayed(mCallback,mEventname & "_btnnextclick")
	End If
End Sub
Public Sub btntoday_MouseClicked(EventData As MouseEvent)
	If xui.SubExists(mCallback,mEventname & "_btntodayclick",2) Then
		CallSubDelayed(mCallback,mEventname & "_btntodayclick")
	End If
End Sub
